# coding: utf-8

"""
    Gradient AI API

    Interface for interacting with Gradient AI.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@gradient.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, Dict
from pydantic import BaseModel, Field, StrictStr, constr, validator

class GetModelSuccess(BaseModel):
    """
    GetModelSuccess
    """
    base_model_id: constr(strict=True, min_length=1) = Field(..., alias="baseModelId")
    id: constr(strict=True, max_length=50, min_length=50) = Field(...)
    latest_update_time: datetime = Field(..., alias="latestUpdateTime")
    name: constr(strict=True, min_length=1) = Field(...)
    type: StrictStr = Field(...)
    additional_properties: Dict[str, Any] = {}
    __properties = ["baseModelId", "id", "latestUpdateTime", "name", "type"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('modelAdapter'):
            raise ValueError("must be one of enum values ('modelAdapter')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetModelSuccess:
        """Create an instance of GetModelSuccess from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetModelSuccess:
        """Create an instance of GetModelSuccess from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GetModelSuccess.parse_obj(obj)

        _obj = GetModelSuccess.parse_obj({
            "base_model_id": obj.get("baseModelId"),
            "id": obj.get("id"),
            "latest_update_time": obj.get("latestUpdateTime"),
            "name": obj.get("name"),
            "type": obj.get("type")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj

